/*
VolgaCTF 2015 Quals
carry challenge

Exploit by Rogdham
2015.05.03
See http://r.rogdham.net/25
Licence: CC0

    This program is free software. It comes without any warranty, to the extent
    permitted by applicable law. You can redistribute it and/or modify it under
    the terms of the CC0 1.0 Universal Licence (French).
    See CC0 https://creativecommons.org/publicdomain/zero/1.0/deed.fr for more
    details.
*/

#include <stdio.h>

// compile with -O3

// WARNING: needs a 64 bit architecture, where long == 64 bits
// I know, but you don't hate time to think too much about these things while
// doing a CTF


unsigned int sum_all(unsigned int x) {
    unsigned int o = 0;
    while(x) {
        o += (x & 1);
        x >>= 1;
    }
    return o;
}

unsigned char test(unsigned int t, unsigned int state, unsigned long target_r) {
    unsigned int mask = 0, taps_mask = 0, c = 0;
    unsigned char m = 0, i;
    // init
    while(t) {
        taps_mask = (taps_mask << 1) | (t & 1);
        t >>= 1;
        m++;
    }
    mask = (1 << m) - 1;
    state &= mask;
    // output
    m--;
    for(i = 0; i < 64; i++) {
        c += sum_all(taps_mask & state);
        if((state & 1) != (target_r & 1)) {
            return 0;
        }
        target_r >>= 1;
        state = (state >> 1) | ((c & 1) << m);
        c >>= 1;
    }
    return 1;
}


int main() {
    unsigned int t, state;
    unsigned long target_r;
    // target_r: beginning of xor of known plaintext and ciphertext, reversed
    target_r = 0x14b9ab5764343233;
    state = target_r & 0xffffffff;
    printf("state: 0x%x\n", state);
    t = 0;
    while(1) {
        if(test(t, state, target_r)) {
            printf("t: 0x%x\n", t); // 0x118a702d
            break;
        }
        t++;
        /* Uncomment to see progress
        if((t & 0xfffff) == 0) {
            fprintf(stderr, "%x\n", t);
        }
        */
        if(t == 0x80000000) {
            return 1;
        }
    }
    return 0;
}
