#!/usr/bin/env python2

'''
VolgaCTF 2015 Quals
mathproblem challenge

Exploit by Rogdham
2015.05.03
See http://r.rogdham.net/25
Licence: CC0

    This program is free software. It comes without any warranty, to the extent
    permitted by applicable law. You can redistribute it and/or modify it under
    the terms of the CC0 1.0 Universal Licence (French).
    See CC0 https://creativecommons.org/publicdomain/zero/1.0/deed.fr for more
    details.
'''

import socket
import sys


operators = (
    (lambda x, y: x + y, '+'),
    (lambda x, y: x - y, '-'),
    (lambda x, y: x * y, '*'),
    (lambda x, y: x / y, '/'),
)


def countdown(t, remaining):
    if len(remaining) == 1:
        if remaining[0][0] == t:
            return remaining[0][1]
        return False
    # pick first
    for a, sa in remaining:
        remaining0 = remaining[:]
        remaining0.remove((a, sa))
        # pick second
        for b, sb in remaining0:
            remaining1 = remaining0[:]
            remaining1.remove((b, sb))
            # pick operator
            for op, sop in operators:
                remaining2 = remaining1[:]
                try:
                    remaining2.append((op(a, b),
                                       '('+sa+sop+sb+')'))
                except ZeroDivisionError:
                    continue
                result = countdown(t, remaining2)
                if result:
                    return result


class Exploit(object):

    def __init__(self, host, port):
        self.b = ''
        self.host = (host, port)

    def readline(self):
        while '\n' not in self.b:
            r = self.s.recv(1024)
            if not r:
                sys.exit(0)
            self.b += r
        l, self.b = self.b.split('\n', 1)
        print '>>>', l
        return l

    def send(self, l):
        print '<<<', l
        self.s.sendall('%s\n' % l)

    def run(self):
        self.s = socket.socket()
        self.s.connect(self.host)
        while True:
            line = self.readline()
            if line.startswith('Round'):
                self.solve(self.readline())

    def solve(self, line):
        line = line.split()
        line.pop(4)  # remove 'equals'
        a, b, c, d, t = map(int, line)
        self.send(countdown(t, [(x, str(x)) for x in (a, b, c, d)]))


if __name__ == '__main__':
    Exploit('mathproblem.2015.volgactf.ru', 8888).run()
