#!/usr/bin/env python2

'''
VolgaCTF 2015 Quals
strange text challenge

Exploit by Rogdham
2015.05.03
See http://r.rogdham.net/25
Licence: CC0

    This program is free software. It comes without any warranty, to the extent
    permitted by applicable law. You can redistribute it and/or modify it under
    the terms of the CC0 1.0 Universal Licence (French).
    See CC0 https://creativecommons.org/publicdomain/zero/1.0/deed.fr for more
    details.
'''

from collections import defaultdict
import matplotlib.pyplot as plt

def show(k):
    x = []
    y = []
    for i, part in enumerate(parts):
        for a, b in part:
            x.append(a + 9 - i)
            y.append(b)
    plt.plot(x, y, marker='o', linestyle='--')
    plt.show()


def read(filename):
    d = defaultdict(list)
    with open(filename) as f:
        l = iter(f.read().split(',')[2:-1])
        for p in l:
            a, b, c = p.split('.')
            d[b].append((float(a + '.' + c), float(l.next())))
    return d


if __name__ == '__main__':
    d = read('strange_text.txt')
    parts = []
    for k in reversed(sorted(d.keys())):
        parts.append(d[k])
    show(parts)
